using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Threading;

namespace spring16_2sem_wintcpserver01
{   // tcp server page 175
    public partial class Form1 : Form
    {
        private Socket connection;
        private NetworkStream socketStream;
        private BinaryReader reader;
        private BinaryWriter writer;
        private Thread serverThread;

        public Form1()
        {
            InitializeComponent();
            string hostname = Dns.GetHostName();
            IPHostEntry local = Dns.GetHostEntry(hostname);
            foreach (IPAddress ipa in local.AddressList)
                textBox1.Text = ipa.ToString();
        }

        public void RunServer()
        {
            try
            {
                //create listener
                Int32 port = 5000;
                IPAddress localAddr = IPAddress.Parse("127.0.0.1");
                TcpListener server = new TcpListener(localAddr, port);
                //start listening
                server.Start();
                //establish and accept connection
                connection = server.AcceptSocket();
                //create a networkstream for the socket
                socketStream = new NetworkStream(connection);
                //create read and write objects to send data through stream
                writer = new BinaryWriter(socketStream);
                reader = new BinaryReader(socketStream);
                // display in listbox
                listBox1.Items.Add("connection made");
                //tell the client
                writer.Write("Message from Server : connection OK");
                //now loop for receiving data
                string msgFromClient = null;
                do
                {
                    try
                    {
                        //read string sent by client - terminate if QUIT
                        msgFromClient = reader.ReadString();
                        //wont hang it will be in a thread
                        listBox1.Items.Add(msgFromClient); // test jkp
                        //and echo data
                        writer.Write(msgFromClient);
                    }
                    catch (Exception)
                    {
                        break;
                    }

                }
                while (msgFromClient != "QUIT");
                listBox1.Items.Add("Client disconnected");
                //close the connection
                reader.Close();
                writer.Close();
                socketStream.Close(); 
                connection.Close();
                Application.Exit();
            }
            catch (Exception error)
            {
                MessageBox.Show(error.ToString());
            }
        }//end runserver

        private void button1_Click(object sender, EventArgs e)
        {
            // listen
            serverThread= new Thread(new ThreadStart(RunServer));
            serverThread.Start();
            button1.Enabled=false;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            // disconnect
            try
            {
                if(connection.Connected)
                {
                    reader.Close();
                    writer.Close();
                    socketStream.Close();
                    connection.Close();
                    button2.Enabled=false;
                    serverThread.Abort();
                }

            }
            catch(Exception error)
            {
                MessageBox.Show(error.ToString());
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            CheckForIllegalCrossThreadCalls = false;
        }
    }
}